#include "hipster.h"

Hipster::Hipster(unsigned int i)
{
	imie = "Hipek";
	modneSkarpety = NULL;
	if (i < 3)
		boskiTelefon.ustawSponsora(i);
	else
		boskiTelefon.ustawSponsora(0);
}

Hipster::Hipster(const Hipster &h)
{
	imie = h.imie;
	if (h.modneSkarpety != NULL)
		modneSkarpety = new Skarpety(modneSkarpety);
	else
		modneSkarpety = NULL;
	boskiTelefon = h.boskiTelefon;
	welnainaCzapka = h.welnainaCzapka;
}

void Hipster::zalozSkarpety()
{
	if(modneSkarpety == NULL)
		modneSkarpety = new Skarpety;
}

void Hipster::zmienSkarpety(string kolor)
{
	if(modneSkarpety != NULL)
		modneSkarpety->zmienKolor(kolor);
}

void Hipster::zmienSkarpety(int rozmiar)
{
	if(modneSkarpety != NULL)
		modneSkarpety->zmienRozmiar(rozmiar);
}

void Hipster::przedstawSie()
{
	cout << "Heja! Jestem hipster " << imie << endl;
	cout << "Moja welniana czapeczka nie jest nowa. Oto jej wiek: " << welnainaCzapka.sprawdzLata() << "." << endl;
	if(welnainaCzapka.spradzSzpan())
		cout << "Oczywiscie jest szpanerska :)" << endl;
	else
		cout <<"Eeee... Ten... nooo..." << endl;
	if(boskiTelefon.sprawdzGietkosc())
		cout << "Moj boski fon oczywiscie sie wygina. Bardzo hipstersko.";
	else
		cout << "Moj boski fn sie nie wygina. Jeszcze...";
	cout << " Mam go od ";
	Sponsor s = boskiTelefon.sprawdzSponsora();
	switch(s)
	{
		case MAMA :
			cout << "mamusi." << endl;
			break;
		case TATA :
			cout << "tatusia." << endl;
			break;
		case BABCIA :
			cout << "babci." << endl;
			break;
		default :
			break;
	}
	if(modneSkarpety == NULL)
		cout << "Nie mam skarpet... Kupisz mi?" << endl;
	else
	{
		cout << "Mam super hipsterskie skarpety! Sa " << modneSkarpety->sprawdzKolor() << endl; 
		if(modneSkarpety->sprawdzGrochy())
			cout << "I maja grochy. Czad!" << endl;
	}
	cout << endl;
}

const Hipster& Hipster::operator=(const Hipster &h)
{
	if(this != &h)
	{
		welnainaCzapka = h.welnainaCzapka;
		boskiTelefon = h.boskiTelefon;
		if(h.modneSkarpety != NULL)
		{
			modneSkarpety = new Skarpety();
			*modneSkarpety = * h.modneSkarpety;
		}
	}
	return *this;
}

Hipster Hipster::operator+(Hipster h)
{
	Hipster doZwrotu(*this);

	doZwrotu.imie = imie+" "+h.imie;
	doZwrotu.welnainaCzapka.ustawLata(welnainaCzapka.sprawdzLata()+h.welnainaCzapka.sprawdzLata());

	return doZwrotu;
}

Hipster& Hipster::operator++()
{
	if(modneSkarpety == NULL)
		modneSkarpety = new Skarpety;

	return *this;
}

Hipster& Hipster::operator--()
{
	if(modneSkarpety != NULL)
	{
		delete modneSkarpety;
		modneSkarpety = NULL;
	}

	return *this;
}